@import 'src/assets/scss/core/functions';
@import "src/assets/scss/core/breakpoints";
@import "src/assets/scss/core/mixins";
@import "src/assets/scss/settings";

.select {
  $arrow-height-large: 7px;
  $arrow-height: 6px;

  position: relative;
  width: 100%;

  &::before {
    content: "";
    position: absolute;
    top: 50%;
    right: 15px;
    z-index: 10;
    width: 4px;
    height: 4px;
    border: 1px solid $gray-dark-color;
    border-top-color: transparent;
    border-right-color: transparent;
    transform: rotate3d(0, 0, 1, -45deg) translateY(-6px);
  }

  &:hover::before {
    border: 1px solid $primary-color;
    border-top-color: transparent;
    border-right-color: transparent;
  }

  &--invalid:hover::before {
    border-color: lighten($red-color, 15%);
    border-top-color: transparent;
    border-right-color: transparent;
  }

  &--disabled:hover::before {
    border: 1px solid $gray-dark-color;
    border-top-color: transparent;
    border-right-color: transparent;
  }

  &--invalid::before {
    border-bottom-color: $red-color;
    border-left-color: $red-color;
  }

  &--opened {
    z-index: 100;

    @include media-breakpoint-up(lg) {
      z-index: 10;
    }
  }

  &:hover {
    border-color: darken($gray-light-color, 10%);
  }

  &__field input {
    @include input();

    //position: relative;
    //display: flex;
    //align-items: center;

    @include placeholder() {
      opacity: 0;
    }

    &:focus {
      @include placeholder() {
        opacity: 1;
      }
    }

    .select--invalid &:focus {
      @include placeholder() {
        color: $red-color;
      }
    }

    .select:hover & {
      border-color: $primary-color;
    }

    .select__loader:not(:empty) ~ & {
      opacity: 0;
    }

    .select--no-shadow & {
      box-shadow: none;
    }

    .select--invalid & {
      border: 1px solid $red-color;
      background-color: rgba($red-color, 0.5);
      color: $red-color;
    }

    .select--invalid:hover & {
      border: 1px solid lighten($red-color, 15%);
    }

    &:disabled,
    &--disabled {
      opacity: 0.4;
      background-color: $gray-light-color;
      cursor: not-allowed;
    }

    .select--no-shadow &:disabled,
    .select--no-shadow &--disabled {
      opacity: 0.2;
    }

    .select--inverted &:disabled,
    .select--inverted &--disabled {
      background-color: $black-color;
      cursor: not-allowed;
    }

    .select:hover &:disabled,
    .select:hover &--disabled {
      border-color: transparent;
    }
  }

  &__field span {
    //user-select: ;
    overflow: hidden;
    text-overflow: ellipsis;
    white-space: nowrap;
    pointer-events: none;
  }

  &__dropdown {
    position: fixed;
    top: 0;
    bottom: 0;
    right: 0;
    z-index: 11;
    display: flex;
    flex-direction: column;
    width: 315px;
    transform: translateX(330px);
    background-color: $gray-light-color;
    box-shadow: 0px 5px 40px rgba($black-color, 0.05);
    transition: all 0.25s ease-in;

    ::ng-deep .page-contacts--details & {
      display: none;
    }

    @include media-breakpoint-up(lg) {
      position: absolute;
      top: 60px;
      left: 0;
      right: 0;
      bottom: unset;
      width: unset;
      padding: 15px 10px;
      display: none;
      background-color: $white-color;
      //border-radius: $border-radius;
      transform: none;
    }

    .select--opened & {
      transform: translateX(0);

      @include media-breakpoint-up(lg) {
        display: block;
      }
    }

    //.select--opened & {
    //  z-index: 100;
    //}
  }

  &__search {
    position: relative;
    padding: 15px;
    font-family: $font-family;
    font-size: 20px;
    line-height: 30px;
    text-transform: uppercase;
    background-color: darken($gray-light-color, 2%);
    border-bottom: 1px solid darken($gray-light-color, 4%);

    @include media-breakpoint-up(lg) {
      display: none;
    }
  }

  &__search input {
    @include placeholder() {
      color: $gray-dark-color;
    }

    width: 100%;
    height: 50px;
    box-sizing: border-box;
    border: none;
    padding: 10px;
    font-family: $font-family--secondary;
    font-size: 16px;
    line-height: 20px;
    color: $gray-dark-color;
    border: 2px solid transparent;
    border-radius: $border-radius;
    background: rgba(255, 255, 255, 0.6);

    @include focus {
      outline: none;
      border-color: $gray-color;
    }
  }

  &__list {
    margin: 0;
    padding: 10px 0;
    list-style: none;
    overflow-y: auto;
    height: 100vh;

    @include media-breakpoint-up(lg) {
      max-height: 200px;
      height: unset;
      padding: 0;
    }

    @include scollbar();
  }

  &__backdrop {
    position: fixed;
    //display: none;
    z-index: 10;
    top: 0;
    right: 0;
    left: 0;
    bottom: 0;
    background: rgba($black-color, 0.8);

    @include media-breakpoint-up(lg) {
      z-index: -1;
      background: transparent;
    }

    //.select.open & {
    //  display: block;
    //}
  }

  &__loader {
    position: absolute;
    top: 0;
    right: 0;
    bottom: 0;
    left: 0;
    z-index: 10;
    //width: 100%;
    //height: 50px;
    display: flex;
    justify-content: center;
    align-items: center;
    border-radius: $border-radius;
    background: rgba($gray-light-color, 0.4);
    border: 1px solid rgba($gray-light-color, 0.4);
    cursor: not-allowed;

    &:empty {
      position: static;
      display: none;
    }

    .select--no-shadow & {
      opacity: 1;
      background: rgba($black-color, 0.2);
      border-color: transparent;
    }
  }

  &__item {
    position: relative;
    padding: 15px 20px;
    overflow: hidden;
    font-family: $font-family--secondary;
    font-size: 16px;
    line-height: 20px;
    color: #333333;
    text-align: left;
    transition: .15s background-color ease-in;
    cursor: pointer;

    @include media-breakpoint-up(lg) {
      padding: 6px 10px;
    }

    &::before {
      content: "";
      position: absolute;
      top: 0;
      left: 0;
      transform: translateX(100%);
      z-index: -1;
      width: 100%;
      height: 100%;
      background-color: rgba($white-color, 0.6);
      transition: transform 0.25s ease-in;
    }

    &::after {
      content: "";
      position: absolute;
      top: 0;
      left: -1px;
      bottom: 0;
      width: 3px;
      background-color: transparent;
      transition: background-color 0.25s ease-in;
    }

    &::before,
    &::after {
      @include media-breakpoint-up(lg) {
        display: none;
      }
    }

    //
    //&:not(:last-child) {
    //  margin-bottom: 10px;
    //}

    &--active {
      @include media-breakpoint-up(lg) {
        color: $gray-dark-color;
      }
    }

    &--active::before {
      transform: translateX(0);
    }

    &--active::after {
      background-color: $primary-color;
    }

    @include hover {
      color: $gray-dark-color;
    }
  }

  &__empty {
    padding: 20px;
    font-family: $font-family--secondary;
    font-size: 16px;
    line-height: 20px;
    color: #333333;

    @include media-breakpoint-up(lg) {
      padding: 0 10px;
    }
  }

  &__close {
    @include close-button($primary-color);

    position: absolute;
    top: 50%;
    transform: translateY(-50%);
    left: -45px;
    display: none;

    .select--opened & {
      display: block;
    }
  }
}

